# This is an experiment to test the behavior of the Pyrex compiler.

cdef extern from "cppheader.h":
    # Test way to handle overloaded functions.
    int fooi "foo" (int x)
    float foof "foo" (float x)
    # Test way to handle class methods.
    ctypedef struct klass "Klass":
        int x
        int (*two_x)()
        int (*_eq_ "operator ==")(int y)
    # Test way to handle class construction and deletion.
    klass *klassfactory "new Klass" (int x)
    void delete "delete " (void *o)

cdef class Klass:
    """Wraps a C++ class"""
    cdef klass *value

    def __new__(self, int x):
        self.value = klassfactory(x)

    property x:
        def __get__(self):
            return self.value[0].x

    def __richcmp__(x, y, op):
        if isinstance(x, Klass):
            self, other  = x, y
        else:
            self, other = y, x
        if op == 2:
            return self._eq(other)
        if op == 3:
            return not self._eq(other)
        return NotImplemented

    def __add__(self, other):
        return Klass(self.x + other)

    def _eq(self, int y):
        return self.value[0]._eq_(y) != 0

    def two_x(self):
        return self.value[0].two_x()

    def __dealloc__(self):
        delete(self.value)

##    # Generate the (void *) cast C++ does not like
##    cdef the_x(self):
##        return self.value[0].x

def FooI(int x):
    return fooi(x)

def FooF(double x):
    return foof(x)
